(load-extension "./mptn-scheme.so")

(mptn-matcher-set! 'str
		   (mptn-matcher 'init (lambda (arg udata)
					 (display (format "Matcher-init Arg: ~s Udata: ~s~n" arg udata))
					 (values arg (string-length arg) (string-length arg)))
				 'iter-start (lambda (mctl str vars stage data)
					       (display (format "Iter-start Mctl: ~s Str: ~s Vars: ~s Stage: ~s Data: ~s~n"
								mctl str vars stage data))
					       (if (string=? mctl str)
						   str
						   #f))
				 'iter-step (lambda (ictl)
					      (display (format "Iter-Step Ictl: ~s~n" ictl))
					      #f)))

(define mptn (mptn-parse "{x}{str:qz}{y}"))

(mptn-exec-for-each mptn "abcqzdefqzghi" 'tt
		    (lambda (ectl)
		      (display (format "~s~n" (mptn-ectl->alist ectl)))))

